> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create a delivery adjustment

POST https://rest.test.zuora.com/v1/adjustments
Content-Type: application/json

Describes how to create one or more delivery adjustments for a subscription. 

**Notes**: 
- The Delivery Adjustments feature is in the Early Adopter phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. To manage and access this feature through the self-service interface, see [Enable billing features by yourself](https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Billing_Settings/Manage_Features) in the Knowledge Center.
- This operation supports a partial success scenario: when at least one eligible delivery adjustment exists for a given time period, “success = true” as well as eligible delivery adjustments and ineligible delivery adjustments are returned in the response; only when no delivery adjustment is eligible, “success=false” is returned.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/delivery-adjustments/create-adjustment

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTCreateBillingAdjustmentRequestType.

- `endDate` (date, required) — The end date of the delivery adjustment, in `yyyy-mm-dd` format. This is inclusive.
- `startDate` (date, required) — The start date of the delivery adjustment, in `yyyy-mm-dd` format. This is inclusive.
- `accountNumber` (string, optional) — The account number for which the delivery adjustment is created. **Note**: - The account number should be of the subscription owner. - Only one of accountNumber or subscriptionNumber should be provided.
- `chargeNumbers` (list of string, optional) — An optional container to specify charge numbers in the subscription for which the delivery adjustment needs to be created.
- `deferredRevenueAccountingCode` (string, optional) — The accounting code for the deferred revenue, such as Monthly Recurring Liability. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `exclusion` (list of PostCreateBillingAdjustmentRequestTypeExclusionItems, optional) — The charge numbers and the corresponding dates for exclusion of delivery adjustment.
- `reason` (string, optional) — The reason for the delivery adjustment.
- `recognizedRevenueAccountingCode` (string, optional) — The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `revenueRecognitionRuleName` (string, optional) — The name of the revenue recognition rule governing the revenue schedule. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `subscriptionNumber` (string, optional) — The subscription number for which the delivery adjustment is created. **Note**: Only one of accountNumber or subscriptionNumber should be provided.
- `type` (enum, optional) — The type of delivery adjustment.
  - Allowed values: `DeliveryCredit`
- `creditMemoCustomFields` (map from string to PostCreateBillingAdjustmentRequestTypeCreditMemoCustomFields, optional) — Container for custom fields of the Credit Memo object. When creating a delivery adjustment, Zuora generates a credit memo automatically. You can use this field to specify the custom fields of the credit memo associated with this adjustment.

## Response

### 200

OK

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of GetAdjustmentsResponseTypeReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.
- `adjustments` (list of POSTAdjustmentResponseType, optional) — Container for delivery adjustments of a subscription.
- `ineligibleAdjustments` (list of POSTIneligibleAdjustmentResponseType, optional) — Container for ineligible delivery adjustments of a subscription.
- `totalAmount` (double, optional) — The total amount of all the delivery adjustments.
- `totalNumberOfDeliveries` (double, optional) — The total number of all delivery adjustments.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### PostCreateBillingAdjustmentRequestTypeExclusionItems

- `chargeNumbers` (list of string, optional) — The charge numbers to be excluded from delivery adjustment on the specified delivery date.
- `deliveryDate` (date, optional) — The date on which the delivery adjustment has to be excluded, in `yyyy-mm-dd` format.

### PostCreateBillingAdjustmentRequestTypeCreditMemoCustomFields

Custom fields of the Credit Memo object. The name of each custom field has the form *customField*\_\_c. Custom field names are case sensitive. See Manage Custom Fields for more information.

### GetAdjustmentsResponseTypeReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### POSTAdjustmentResponseType

- `adjustmentId` (string, optional) — The system generated delivery adjustment ID.
- `adjustmentNumber` (string, optional) — The system generated delivery adjustment number.
- `amount` (double, optional) — The amount of the delivery adjustment.
- `billingDate` (date, optional) — The billing date is same as the delivery date of the delivery adjustment, in `yyyy-mm-dd` format.
- `chargeNumber` (string, optional) — The charge number in the subscription for which the delivery adjustment is created.
- `creditMemoNumber` (string, optional) — The Credit Memo generated for the delivery adjustment.
- `deferredRevenueAccountingCode` (string, optional) — The accounting code for the deferred revenue, such as Monthly Recurring Liability. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `deliveryDate` (date, optional) — The delivery adjustment date, in `yyyy-mm-dd` format.
- `deliveryDay` (string, optional) — The delivery adjustment day of the week.
- `eligible` (boolean, optional) — The eligible flag is set as true for a successfully created delivery adjustment.
- `reason` (string, optional) — The reason for the delivery adjustment.
- `recognizedRevenueAccountingCode` (string, optional) — The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `revenueRecognitionRuleName` (string, optional) — The name of the revenue recognition rule governing the revenue schedule. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `status` (string, optional) — The status of the delivery adjustment will be `Billed` or `Cancelled`.
- `subscriptionNumber` (string, optional) — The subscription number for which the delivery adjustment is created.

### POSTIneligibleAdjustmentResponseType

- `adjustmentId` (string, optional) — The system generated delivery adjustment ID.
- `adjustmentNumber` (string, optional) — The system generated delivery adjustment number.
- `amount` (double, optional) — The amount of the delivery adjustment.
- `billingDate` (date, optional) — The billing date of the delivery adjustment.
- `chargeNumber` (string, optional) — The charge number in the subscription for which the delivery adjustment is created.
- `deferredRevenueAccountingCode` (string, optional) — The accounting code for the deferred revenue, such as Monthly Recurring Liability. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `deliveryDate` (date, optional) — The delivery adjustment date, in `yyyy-mm-dd` format.
- `deliveryDay` (string, optional) — The delivery adjustment day of the week.
- `eligible` (boolean, optional) — The eligible flag is set as false for an unsuccessful delivery adjustment.
- `errorMessage` (string, optional) — The reason due to which a delivery adjustment is not eligible on the given date.
- `reason` (string, optional) — The reason for the delivery adjustment.
- `recognizedRevenueAccountingCode` (string, optional) — The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `revenueRecognitionRuleName` (string, optional) — The name of the revenue recognition rule governing the revenue schedule. **Note**: For the credit memo generated by the delivery adjustment, if this field is not specified, the value inherits from the subscription rate plan charge.
- `status` (string, optional) — The status of the delivery adjustment.
- `subscriptionNumber` (string, optional) — The subscription number for which the delivery adjustment is created.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "endDate": "2023-02-27",
  "startDate": "2023-02-26",
  "chargeNumbers": [
    "string",
    "string"
  ],
  "deferredRevenueAccountingCode": "string",
  "exclusion": [
    {
      "chargeNumbers": [
        "string",
        "string"
      ],
      "deliveryDate": "2023-02-26"
    },
    {
      "chargeNumbers": [
        "string",
        "string"
      ],
      "deliveryDate": "2023-05-27"
    }
  ],
  "reason": "string",
  "recognizedRevenueAccountingCode": "string",
  "revenueRecognitionRuleName": "string",
  "subscriptionNumber": "string",
  "type": "DeliveryCredit"
}
```

**Response**

```json
{
  "success": true,
  "adjustments": [
    {
      "adjustmentId": "4028818886a2149b0186a237d0ff003b",
      "adjustmentNumber": "ADJ-00000001",
      "amount": -5,
      "billingDate": "2023-02-26",
      "chargeNumber": "C-00000001",
      "creditMemoNumber": "CM00000001",
      "deferredRevenueAccountingCode": "string",
      "deliveryDate": "2023-02-26",
      "deliveryDay": "sunday",
      "eligible": true,
      "reason": "string",
      "recognizedRevenueAccountingCode": "string",
      "revenueRecognitionRuleName": "string",
      "status": "Billed",
      "subscriptionNumber": "A-S00000001"
    }
  ],
  "ineligibleAdjustments": [
    {
      "chargeNumber": "C-00000001",
      "deferredRevenueAccountingCode": "string",
      "deliveryDate": "2023-02-27",
      "deliveryDay": "monday",
      "eligible": false,
      "errorMessage": "Subscription does not have a delivery scheduled for this day",
      "reason": "string",
      "recognizedRevenueAccountingCode": "string",
      "revenueRecognitionRuleName": "string",
      "subscriptionNumber": "A-S00000001"
    }
  ],
  "totalAmount": -5,
  "totalNumberOfDeliveries": 1
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/adjustments"

payload = {
    "endDate": "2023-02-27",
    "startDate": "2023-02-26",
    "chargeNumbers": ["string", "string"],
    "deferredRevenueAccountingCode": "string",
    "exclusion": [
        {
            "chargeNumbers": ["string", "string"],
            "deliveryDate": "2023-02-26"
        },
        {
            "chargeNumbers": ["string", "string"],
            "deliveryDate": "2023-05-27"
        }
    ],
    "reason": "string",
    "recognizedRevenueAccountingCode": "string",
    "revenueRecognitionRuleName": "string",
    "subscriptionNumber": "string",
    "type": "DeliveryCredit"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/adjustments';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"endDate":"2023-02-27","startDate":"2023-02-26","chargeNumbers":["string","string"],"deferredRevenueAccountingCode":"string","exclusion":[{"chargeNumbers":["string","string"],"deliveryDate":"2023-02-26"},{"chargeNumbers":["string","string"],"deliveryDate":"2023-05-27"}],"reason":"string","recognizedRevenueAccountingCode":"string","revenueRecognitionRuleName":"string","subscriptionNumber":"string","type":"DeliveryCredit"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/adjustments"

	payload := strings.NewReader("{\n  \"endDate\": \"2023-02-27\",\n  \"startDate\": \"2023-02-26\",\n  \"chargeNumbers\": [\n    \"string\",\n    \"string\"\n  ],\n  \"deferredRevenueAccountingCode\": \"string\",\n  \"exclusion\": [\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-02-26\"\n    },\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-05-27\"\n    }\n  ],\n  \"reason\": \"string\",\n  \"recognizedRevenueAccountingCode\": \"string\",\n  \"revenueRecognitionRuleName\": \"string\",\n  \"subscriptionNumber\": \"string\",\n  \"type\": \"DeliveryCredit\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/adjustments")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"endDate\": \"2023-02-27\",\n  \"startDate\": \"2023-02-26\",\n  \"chargeNumbers\": [\n    \"string\",\n    \"string\"\n  ],\n  \"deferredRevenueAccountingCode\": \"string\",\n  \"exclusion\": [\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-02-26\"\n    },\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-05-27\"\n    }\n  ],\n  \"reason\": \"string\",\n  \"recognizedRevenueAccountingCode\": \"string\",\n  \"revenueRecognitionRuleName\": \"string\",\n  \"subscriptionNumber\": \"string\",\n  \"type\": \"DeliveryCredit\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/adjustments")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"endDate\": \"2023-02-27\",\n  \"startDate\": \"2023-02-26\",\n  \"chargeNumbers\": [\n    \"string\",\n    \"string\"\n  ],\n  \"deferredRevenueAccountingCode\": \"string\",\n  \"exclusion\": [\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-02-26\"\n    },\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-05-27\"\n    }\n  ],\n  \"reason\": \"string\",\n  \"recognizedRevenueAccountingCode\": \"string\",\n  \"revenueRecognitionRuleName\": \"string\",\n  \"subscriptionNumber\": \"string\",\n  \"type\": \"DeliveryCredit\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/adjustments', [
  'body' => '{
  "endDate": "2023-02-27",
  "startDate": "2023-02-26",
  "chargeNumbers": [
    "string",
    "string"
  ],
  "deferredRevenueAccountingCode": "string",
  "exclusion": [
    {
      "chargeNumbers": [
        "string",
        "string"
      ],
      "deliveryDate": "2023-02-26"
    },
    {
      "chargeNumbers": [
        "string",
        "string"
      ],
      "deliveryDate": "2023-05-27"
    }
  ],
  "reason": "string",
  "recognizedRevenueAccountingCode": "string",
  "revenueRecognitionRuleName": "string",
  "subscriptionNumber": "string",
  "type": "DeliveryCredit"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/adjustments");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"endDate\": \"2023-02-27\",\n  \"startDate\": \"2023-02-26\",\n  \"chargeNumbers\": [\n    \"string\",\n    \"string\"\n  ],\n  \"deferredRevenueAccountingCode\": \"string\",\n  \"exclusion\": [\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-02-26\"\n    },\n    {\n      \"chargeNumbers\": [\n        \"string\",\n        \"string\"\n      ],\n      \"deliveryDate\": \"2023-05-27\"\n    }\n  ],\n  \"reason\": \"string\",\n  \"recognizedRevenueAccountingCode\": \"string\",\n  \"revenueRecognitionRuleName\": \"string\",\n  \"subscriptionNumber\": \"string\",\n  \"type\": \"DeliveryCredit\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "endDate": "2023-02-27",
  "startDate": "2023-02-26",
  "chargeNumbers": ["string", "string"],
  "deferredRevenueAccountingCode": "string",
  "exclusion": [
    [
      "chargeNumbers": ["string", "string"],
      "deliveryDate": "2023-02-26"
    ],
    [
      "chargeNumbers": ["string", "string"],
      "deliveryDate": "2023-05-27"
    ]
  ],
  "reason": "string",
  "recognizedRevenueAccountingCode": "string",
  "revenueRecognitionRuleName": "string",
  "subscriptionNumber": "string",
  "type": "DeliveryCredit"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/adjustments")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```